#if !defined(_FILETREECTRL_H_)
#define _FILETREECTRL_H_

#include <atlctrls.h>
#include <atlctrlx.h>
#include <atlmisc.h>
#include <shlobj.h>
#include "resource.h"

const UINT WM_TREE_BUILD    = WM_APP + 8765;
const UINT WM_TREE_SELECT   = WM_APP + 2246;

class CSystemImageList
{
public:
    CSystemImageList();
    ~CSystemImageList();

    CImageList* GetImageList();

protected:
    void AddSystemIcon(DWORD dwFolder);
    void AddFileTypeIcon(SHFILEINFO * pSfi, LPCTSTR lpExt, HICON hDefault);

protected:
    CImageList m_ImageList;
};

class CFileTreeCtrl : public CWindowImpl< CFileTreeCtrl, CTreeViewCtrl>
{
public:
    CFileTreeCtrl::CFileTreeCtrl()
    {
    }

    virtual ~CFileTreeCtrl(){};
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    virtual BOOL SubclassWindow(HWND hWnd);

    CString GetSelectedPath();

    BEGIN_MSG_MAP(CWtlFileTreeCtrl)
        MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClick)
        MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonUp)
        MESSAGE_HANDLER(WM_TREE_BUILD, OnTreeBuilding)
        REFLECTED_NOTIFY_CODE_HANDLER(TVN_ITEMEXPANDING, OnItemExpanding)
        DEFAULT_REFLECTION_HANDLER()
    END_MSG_MAP()

    LRESULT OnLButtonDblClick(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnRButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnTreeBuilding(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnItemExpanding(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

    void OnTreeRefresh();

protected:

    void        DisplayPath(CString strPath, HTREEITEM hParent);
    void        DisplayRoot();
    int         GetIconIndex(const CString strFilename, bool bIsFolder);
    int         GetIconIndex(HTREEITEM hItem);
    CString     GetItemPath(HTREEITEM hItem);
    BOOL        HasChildEntries(const CString strDirectory);
    HTREEITEM   InsertFileItem(const CString strFile, const CString strPath, bool bIsFolder, HTREEITEM hParent);
    BOOL        IsEqual(CString strValue1, CString strValue2);
    BOOL        IsFolder(HTREEITEM hItem);

    CSystemImageList m_SysImageList;
    CString     m_strRootFolder;
};

#endif //_FILETREECTRL_H_
